// HTML2EMail
// embedded email processing
// (c)2002,2003 Oliver Michalak / werk01.de

var objectList = new Array();

function processEmbedded (srcFilename) {
	objectList = new Array();
	if (!app.setProgress (0)) {
		processBreak = true;
		return true;
	}
	processObject = 0;
	processFile = srcFilename.substr(srcFilename.lastIndexOf('/')+1);

	// get source...
	var srcFile = JSXFile (srcFilename);
	if (!srcFile.exists)
		return false;
	// copy file...
	var destBodyFilename = srcFilename.substr (0, srcFilename.lastIndexOf('.'))+h2eEmbedded.padBody.value+'.txt';
	// remove old...
	var destBodyFile = JSXFile (destBodyFilename);
	if (destBodyFile.exists)
		destBodyFile.remove();
	// copy new body into location...
	destBodyFile = JSXFile (srcFilename);
	if (!destBodyFile.copy (destBodyFilename))
		return false;
	destBodyFile = JSXFile (destBodyFilename); // bugfix

	// retrieve array of objects to be attached and fix html-source-code...
	var doc = destBodyFile.openMarkup();
	destBodyFile.close();
	if (!doc)
		return false;

	// foreground images...
	for (var j=0; j<doc.element.getSubElementCount('img'); j++) {
		var obj = doc.element.getSubElement('img', j);
		obj.src = objectListAdd (obj, 'src');
	}
	// body background image...
	var obj = doc.element.getSubElement('body', 0);
	if (obj.background != undefined)
		obj.background = objectListAdd (obj, 'background');

	// table background images...
	for (var j=0; j<doc.element.getSubElementCount('table'); j++) {
		var obj = doc.element.getSubElement('table', j);
		if (obj.background != undefined)
			obj.background = objectListAdd (obj, 'background');
	}
	// table cell background images...
	for (var j=0; j<doc.element.getSubElementCount('td'); j++) {
		var obj = doc.element.getSubElement('td', j);
		if (obj.background != undefined)
			obj.background = objectListAdd (obj, 'background');
	}

	doc.reparse();
	doc.save();
	doc.close();

	var bound = '=_'+id(20);

	// header...
	if (h2eEmbedded.writeHead.state) {
		var destHeadFilename = srcFilename.substr (0, srcFilename.lastIndexOf('.'))+h2eEmbedded.padHead.value+'.txt';
		var destHeadFile = JSXFile (destHeadFilename);
		if (destHeadFile.exists)
			destHeadFile.remove();
		destHeadFile = JSXFile (destHeadFilename);
		var headcode = 'Mime-Version: 1.0\n';
		headcode += 'Content-Type: multipart/related; boundary="'+bound+'"\n\n';
		if (destHeadFile.open('wb', 'BINARY')) {
			destHeadFile.write(headcode);
			destHeadFile.close();
		}
	}

	// html-body...
	var bodycode = '';
	var altcode = h2eEmbedded.alternateText.value;
	if (altcode.length) {
		var subbound = '=_'+id(20);
		altcode += '\n\n';
		bodycode += qpencode(altcode)+'\n';
		bodycode += '--'+bound+'\n';
		bodycode += 'Content-Type: multipart/alternative; boundary="'+subbound+'"\n\n';
		bodycode += '--'+subbound+'\n';
		bodycode += 'Content-Type: text/plain; charset=ISO-8859-1\n';
		bodycode += 'Content-Transfer-Encoding: quoted-printable\n\n';
		bodycode += qpencode(altcode)+'\n';
		bodycode += '--'+subbound+'\n';
		bodycode += 'Content-Type: text/html; charset=ISO-8859-1\n';
	}
	else
		bodycode += '--'+bound+'\n';

	if (h2eEmbedded.Encode.state) {
		bodycode += 'Content-Transfer-Encoding: base64\n\n';
		if (destBodyFile.open('rb', 'BINARY')) {
			bodycode += b64encode(destBodyFile.read())+'\n';
			destBodyFile.close();
		}
	}
	else {
		bodycode += 'Content-Transfer-Encoding: quoted-printable\n\n';
		if (destBodyFile.open('rb', 'BINARY')) {
			bodycode += '<!-- HTML2EMail start -->\n'+destBodyFile.read()+'\n<!-- HTML2EMail end -->\n\n';
			destBodyFile.close();
		}
	}

	if (altcode.length)
		bodycode += '--'+subbound+'--\n\n\n';

	// image-attachment...
	var baseFilename = srcFile.url.substr(0, srcFile.url.lastIndexOf('/')+1);
	for (objId in objectList) {
		bodycode += '--'+bound+'\n';
		var objName = objectList[objId].substr (objectList[objId].lastIndexOf ('/')+1);
		var objType = objName.substr (objName.lastIndexOf('.')+1);
		if (objType == 'jpg')	objType = 'jpeg';
		bodycode += 'Content-Type: image/'+objType+'; name="'+objName+'"\n';
		bodycode += 'Content-ID: <'+objId+'>\n';
		bodycode += 'Content-Transfer-Encoding: base64\n';
		bodycode += 'Content-Disposition: inline; filename="'+objName+'"\n\n';
		bodycode += data2b64 (objectList[objId], baseFilename)+'\n';
	}
	bodycode += '--'+bound+'--\n';
	if (destBodyFile.open('wb', 'BINARY')) {
		destBodyFile.write(bodycode);
		destBodyFile.close();
	}

	// php...
	if (h2eEmbedded.writeCode.state && h2eEmbedded.to.value.length && h2eEmbedded.subject.value.length) {
		var destCodeFilename = srcFilename.substr (0, srcFilename.lastIndexOf('.'))+'_mail.php';
		var destCodeFile = JSXFile (destCodeFilename);
		if (destCodeFile.exists)
			destCodeFile.remove();
		var phpcode = '<?\n$mailBody = implode("", @file("'+destBodyFilename.substr (destBodyFilename.lastIndexOf('/')+1)+'"));\n';
		phpcode += 'mail ("'+h2eEmbedded.to.value+'", "'+h2eEmbedded.subject.value+'", $mailBody, "';
		if (h2eEmbedded.from.value.length)
			phpcode += 'From: '+h2eEmbedded.from.value+'\\nReply-To: '+h2eEmbedded.from.value+'\\n';
		phpcode += 'Mime-Version: 1.0\\nContent-Type: multipart/related; boundary=\\"'+bound+'\\"\\n\\n");\n?>\n';
		destCodeFile = JSXFile (destCodeFilename);
		if (destCodeFile.open('wb', 'BINARY')) {
			destCodeFile.write(phpcode);
			destCodeFile.close();
		}
	}

	if (sending && !sendMail (destBodyFilename, h2eEmbedded.from.value, h2eEmbedded.to.value, h2eEmbedded.subject.value, bound))
		return false;

	return true;
}

function objectListAdd (obj, attr) {
	eval ('var value = obj.'+attr+';')
	for (objKey in objectList) {
		if (value == objectList[objKey]) {
			return 'cid:'+objKey;
		}
	}
	var objId = id(20);
	objectList[objId] = value;
	return 'cid:'+objId;
}

function traverseEmbedded (h2eCollection) {
	var result = true;
	var h2eRef = h2eCollection.first();
	while (h2eRef) {
		if (processBreak)
			break;
		switch (h2eRef.type) {
			case 'html':
				if (!processEmbedded (h2eRef.longUrl))
					return false;
				break;

			case 'folder':
				result &= traverseEmbedded (h2eRef.getFiles());
		}
		h2eRef = h2eCollection.next();
	}
	return result;
}
